
typedef unsigned char player_t;
typedef signed char coord_t;
typedef player_t abalone_cells[9][9]; /* [row][column] */

struct abalone {
	/* Historic info */
	struct abalone *previous;
	int refcnt;
	char prevcmd[9];
	player_t prevplayer;

	/* Current info */
	abalone_cells cell;
	unsigned char lostpieces[3];
};

struct abalone *new_abalone(void);
void free_abalone(struct abalone *);

void abalone_print(struct abalone *);
struct abalone *abalone_move(struct abalone *, player_t player, const char *cmd);
extern const char *abalone_error;	/* last error message */
int isoffboard(coord_t, coord_t);

/* A function that plays player 1 - returning a command string */
typedef const char * (*playerfn_t)(struct abalone *, player_t);

#define OTHER(player)   ((player) == 1 ? (player_t)2 : (player_t)1)
#define WINNER(a)	((a->lostpieces[1] == 6) ? (player_t)2 : \
			 (a->lostpieces[2] == 6) ? (player_t)1 : \
						   (player_t)0)

