#include <stdio.h>
#include <unistd.h>
#include "abalone.h"
#include "cuser.h"
#include "user.h"
#include "ai1.h"

int
printmoves(a)
	struct abalone *a;
{
	int n;
	if (a == NULL)
		return 0;
	n = printmoves(a->previous);
	if (a->previous != NULL) {
		printf("#%d: player %d: %s\n", n, a->prevplayer, a->prevcmd);
		if (a->lostpieces[1] != a->previous->lostpieces[1] ||
		    a->lostpieces[2] != a->previous->lostpieces[2])
			printf("  score: %d-%d\n",
				a->lostpieces[1], a->lostpieces[2]);
	}
	return n + 1;
}

int
playgame(players)
	playerfn_t *players;
{
	const char *cmd;
	struct abalone *a, *anext;
	int p;
	int winp;

	a = new_abalone();
	for (p = 0; !WINNER(a); p = 1-p) {
		abalone_print(a);

		cmd = (*players[p])(a, p + 1);
		printf("[%d]: %s\n", p, cmd);
		anext = abalone_move(a, p + 1, cmd);
		if (anext == NULL) {
			printf("Error: %s\n", abalone_error);
			free_abalone(a);
			return 1-p;
		}
		a = anext;
	}

	printmoves(a);
	abalone_print(a);
	printf("Player %d wins.\n", WINNER(a));
	winp = WINNER(a) - 1;
	free_abalone(a);
	return winp;
}

int
main(argc, argv)
	int argc;
	char *argv[];
{
	playerfn_t players[2] = { 
		/* cuser_playerfn */
		/* user_playerfn */
		/* ai1_playerfn */
		cuser_playerfn, ai1_playerfn
	};
	/* int winner = */ playgame(players);
	exit(0);
}
